<template>
  <!-- TODO: Split widgets to different vue files -->
  <b-form-group :label="question.field.widget.label"
                :label-for="`${question.reference}-input`"
                :label-col-sm="3"
                :content-cols-sm="9"
                :description="question.field.widget.help_text">

    <!-- text_field -->
    <b-form-input v-if="question.field.widget.type === 'text_field'"
                  :id="`${question.reference}-input`"
                  :placeholder="question.field.widget.placeholder"
                  :value="answer"
                  :state="validationState"
                  type="text"
                  v-model="inputValue"
                  aria-describedby="input-live-feedback"
                  @input="setValue()">
    </b-form-input>

    <!-- integer_field -->
    <b-form-input v-if="question.field.widget.type === 'integer_field'"
                  :id="`${question.reference}-input`"
                  :placeholder="question.field.widget.placeholder"
                  :value="answer"
                  :state="validationState"
                  v-model="inputValue"
                  aria-describedby="input-live-feedback"
                  @input="setValue()">
    </b-form-input>

    <b-form-invalid-feedback id="input-live-feedback">
      {{validationError}}
    </b-form-invalid-feedback>
  </b-form-group>
</template>

<script>
import {CONF_ANSWER_SET} from "@/store/actions/configuration";

export default {
  name: "InputField",
  props: {
    questionSetReference: String,
    question: Object,
    answer: String,
  },
  data() {
    return {
      inputValue: this.$props.answer,
      validationSet: this.$props.question.field.validation,
      validationError: null,
      validationState: null
    }
  },
  methods: {
    setValue: function () {
      if(this.validateInput(this.inputValue)) {
        this.$store.dispatch(CONF_ANSWER_SET, {
          questionSetReference: this.questionSetReference,
          questionReference: this.question.reference,
          answer: this.inputValue
        })
      }
    },
    validateInput: function(input) {
      let validations = this.validationSet
      let isValid = true

      for(let i = 0; i < Object.keys(validations).length; i++) {
        if('required' in validations) {
          if(!this.validateRequired(input, validations['required'])){isValid = false; break}
        }
        if('min_length' in validations) {
          if(!this.validateMinLength(input, validations['min_length'])){isValid = false; break}
        }
        if('max_length' in validations) {
          if(!this.validateMaxLength(input, validations['max_length'])){isValid = false; break}
        }
        if('min' in validations) {
          if(!this.validateMin(Number(input), validations['min'])){isValid = false; break}
        }
        if('max' in validations) {
          if(!this.validateMax(Number(input), validations['max'])){isValid = false; break}
        }
      }
      if(isValid){
        this.validationError = null
        this.validationState = true
      } else {
        this.validationState = false
      }
      return isValid
    },
    validateRequired: function(input, isRequired) {
      if(isRequired && input === ""){
        this.validationError = "Het beantwoorden van deze vraag is verplicht"
        this.validationState = false
        return false
      }
      return true
    },
    validateMinLength: function(input, minLength) {
      if(input.length < minLength) {
        this.validationError = `Antwoord moet minimaal ${minLength} karakters hebben.`
        return false
      }
      return true
    },
    validateMaxLength: function(input, maxLength) {
      if (input.length > maxLength) {
        this.validationError = `Antwoord mag maximaal ${maxLength} karakters hebben.`
        return false
      }
      return true
    },
    validateMin: function(input, min){
      if(!Number.isInteger(input)) {
        this.validationError = "U dient een getal op te geven."
        return false
      }
      if(input < parseInt(min)){
        this.validationError = `Dit getal mag niet lager dan ${min} zijn.`
        return false
      }
      return true
    },
    validateMax: function(input, max){
      if(input > parseInt(max)){
        this.validationError = `Dit getal mag niet hoger dan ${max} zijn.`
        return false
      }
      return true
    }
  },
}
</script>

<style scoped>
</style>
